
QGIS Application - Bug report #13078

Size of legend items

2015-07-06 02:01 AM - Holger Naumann

Status: Closed

Priority: Normal

Assignee: Vincent Mora

Category: Symbology

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 21146

Description

The legend looks ugly if i use map units in symbology.

It looks very good in < 2.10.

Related issues:

Related to QGIS Application - Bug report # 14172: QGIS freezes after canvas r... Closed 2016-01-26

Associated revisions

Revision 8776449a - 2015-08-12 03:22 PM - Vincent Mora

Fix legend symbol size when using map units

fix #13078

The computation of icon sizes for legend symbols has been moved to

QgsLayerTreeModel::legendInvalidateMapBasedData() susch that icon size

is recomputed when zooming.

Revision 7d1a8d30 - 2015-08-18 03:05 AM - Martin Dobias

Merge pull request #2245 from vmora/issue13078

Fix legend symbol size when using map units (fix #13078)

History

#1 - 2015-07-06 02:32 AM - Nyall Dawson

Can you share your project?

#2 - 2015-07-06 02:36 AM - Giovanni Manghi

- Status changed from Open to Feedback

#3 - 2015-07-06 02:43 AM - Holger Naumann

- File projekt.zip added

- File punktsymbole.zip added

- File style.zip added

No problem.
#4 - 2015-07-06 03:32 AM - Nyall Dawson

- Assignee set to Vincent Mora

Vincent - looks related to your legend related changes, mind taking a look?

#5 - 2015-07-31 02:38 AM - Giovanni Manghi

- Status changed from Feedback to Open

#6 - 2015-07-31 05:50 AM - Vincent Mora

Nyall, it definitely looks like that, but I wasn't able to open the project when I tried (I think I forgot the symbols or something). I'm on a vacation at the

moment, but I'll try and have a look asap.

Holger, what happens if you use mm instead of map units, does it look better, does the zoom level change anything ?

#7 - 2015-08-03 05:46 AM - Holger Naumann

- File example.png added

Hi Vincent,

if units are in mm, it is ok. But if one symbol is in mapunits, legend is broken.

#8 - 2015-08-05 02:32 AM - Vincent Mora

Hi Holger,

Thanks for the update. The thing that seems to be broken seems to be the cropping of the symbol, the symbol size is right but the symbol takes way to

much place. I'll have a look asap.

#9 - 2015-08-05 09:02 AM - Vincent Mora

Nyall, I have a lead: when QgsSymbolV2LegendNode::minimumIconSize is called by

QgsDefaultVectorLayerLegend::createLayerTreeModelLegendNodes, the model() is null, whereas it is not when QgsSymbolV2LegendNode::data() is

called with decoration rôle.

For what I understand, it's a matter of setting the correct parent for the node in createLayerTreeModelLegendNodes. If you or Matthias could give me a

hint, I'd be gratefull.

#10 - 2015-08-08 02:21 AM - Nyall Dawson

Vmora - Martin will be the one to contact about this, he's got the most knowledge of how the legends work...

#11 - 2015-08-13 12:05 PM - Vincent Mora

- Pull Request or Patch supplied changed from No to Yes
The fix is here https://github.com/qgis/QGIS/pull/2245

Holger: thanks for the report.

Martin: thanks for the pointers.

#12 - 2015-08-17 06:06 PM - Martin Dobias

- Status changed from Open to Closed

Fixed in changeset commit:"7d1a8d30199e2b6bf2669478f474c0911d04f6b1".

#13 - 2015-08-24 04:15 AM - Holger Naumann

- Status changed from Closed to Reopened

- File Bildschirmfoto_von_»2015-08-24_13-01-43«.png added

Hi Vincent, the problem is solved in the mapwindow. But in print composer, the problem exist.

#14 - 2015-08-29 03:20 PM - Nyall Dawson

Please note that the scaling of legend shapes in composer legends is intentional and is the same beahviour as previous versions. So that's not an issue.

However, it seems like the size of the legend isn't calculated correctly on composer load when the legend contains shape sizes in map units - the legend is

set to a massive width & height. Forcing a refresh of the legend fixes the size.

#15 - 2015-08-29 03:22 PM - Nyall Dawson

- Status changed from Reopened to Closed

Actually - that's a unrelated issue. Closing this.

Files

legende_1.8.2.png 253 KB 2015-07-06 Holger Naumann

legende_master.png 210 KB 2015-07-06 Holger Naumann

map.png 186 KB 2015-07-06 Holger Naumann

projekt.zip 40.5 KB 2015-07-06 Holger Naumann

punktsymbole.zip 161 KB 2015-07-06 Holger Naumann

style.zip 19.7 KB 2015-07-06 Holger Naumann

example.png 199 KB 2015-08-03 Holger Naumann

Bildschirmfoto_von_»2015-08-24_13-01-43«.png 508 KB 2015-08-24 Holger Naumann
